10   M$="*******************************************************************************"
20   CLS
30   PRINT M$
40   PRINT
50   PRINT "                          1% RESISTOR FINDING PROGRAM "
60   PRINT:PRINT M$
70   PRINT
80   PRINT "                   This program will find the two closest values of"
90   PRINT "                the 96 standard 1% resistor decade, to generate"
100  PRINT "                a specified voltage ('V3') determined by the "
110  PRINT "                given string voltages ('V1'&'V2').  It will ask"
120  PRINT "                you for the string voltages, and what the "
130  PRINT "                generated voltage (V3) that you wish to obtain is."
140  PRINT "                In all cases, V1 should be given as the most"
150  PRINT "                positive, V2 the most negative, and V3 anywhere"
160  PRINT "                between the two."
170  PRINT "                   R1 is the resistor tied to the most positive "
180  PRINT "                voltage and R2 is the resistor tied to the most "
190  PRINT "                negative voltage."
200  PRINT:PRINT
210  INPUT "                Type <RETURN> to continue....";BG$
220  CLS
230  FOR J=1 TO 5:PRINT:NEXT J
240  INPUT "                Input V1 (most positive string voltage):  ";V1
250  INPUT "                Input V2 (most negative string voltage):  ";V2
260  IF V2>V1 THEN GOTO 940
270  INPUT "                Input V3 (desired generated voltage):  ";V3
280  IF V3=<V2 OR V3>=V1 THEN GOTO 970
290  GAIN=((V1-V2)-V3+V2)/(V3-V2)
300  PRINT "                Ratio for computation =";GAIN
310  DIM SCRATCH(96)
320  DIM DENOM(96)
330  DIM NEUM(96)
340  DENOMXMULT=1
350  NEUMXMULT=1
360  R1=0
370  R2=0
380  MISTAKE#=10000
390  IF GAIN>9.760002 THEN NEUMXMULT=10
400  IF GAIN<.102459 THEN DENOMXMULT=10
410  IF GAIN>97.60002 THEN NEUMXMULT=100
420  IF GAIN<.0102459 THEN DENOMXMULT=100
430  IF GAIN>976.0002 THEN NEUMXMULT=1000
440  IF GAIN<1.02459E-03 THEN DENOMXMULT=1000
450  FOR I=1 TO 96
460  READ SCRATCH(I)
470  DENOM(I)=DENOMXMULT*SCRATCH(I)
480  NEUM(I)=NEUMXMULT*SCRATCH(I)
490  NEXT I
500  FOR J=1 TO 96
510  PRINT J
520  FOR K=1 TO 96
530  DERIVE=NEUM(J)/DENOM(K)
540  NEWXMISTAKE#=ABS(GAIN-DERIVE)
550  IF NEWXMISTAKE#>MISTAKE# THEN 590
560  MISTAKE#=NEWXMISTAKE#
570  R2=DENOM(K)
580  R1=NEUM(J)
590  NEXT K
600  NEXT J
610  CLS
620  FOR J=1 TO 5
630  PRINT
640  NEXT J
650  PRINT "                 The desired R1/R2 ratio was ";GAIN
660  PRINT "                 The best that can be done with"
670  PRINT "                 the standard 96 1% resistor values"
680  PRINT "                 are:"
690  PRINT
700  PRINT "                 R1=   ";R1" ohms"
710  PRINT "                 R2=   ";R2" ohms"
720  PRINT "                 The ratio of the computed values of R1/R2 = ";R1/R2
730  PRINT 
740  PRINT "                 The desired voltages are:"
750  PRINT "                 V1="V1 "volts; V2="V2 "volts; and V3="V3" volts."
760  PRINT
770  PRINT "                 If R1=" R1", and if R2=" R2"then:"
780  PRINT "                 V3 will be:   "(((V1-V2)*R2)/(R1+R2))+V2 "volts!!"
790  PRINT
800  PRINT "                 Error is ";100*(ABS(((R1/R2)-GAIN)/GAIN));"%"
810  PRINT
820  PRINT "                 Calculations complete"
830  PRINT CHR$(7);:FOR T=1 TO 1000:NEXT:GOTO 830
840  END
850  DATA 1.00,1.02,1.05,1.07,1.10,1.13,1.15,1.18,1.21,1.24
860  DATA 1.27,1.30,1.33,1.37,1.40,1.43,1.47,1.50,1.54,1.58
870  DATA 1.62,1.65,1.69,1.74,1.78,1.82,1.87,1.91,1.96,2.00
880  DATA 2.05,2.10,2.15,2.21,2.26,2.32,2.37,2.43,2.49,2.55
890  DATA 2.61,2.67,2.74,2.80,2.87,2.94,3.01,3.09,3.16,3.24,3.32
900  DATA 3.40,3.48,3.57,3.65,3.74,3.83,3.92,4.02,4.12,4.22,4.32,4.42
910  DATA 4.53,4.64,4.75,4.87,4.99,5.11,5.23,5.36,5.49,5.62,5.76,5.90
920  DATA 6.04,6.19,6.34,6.49,6.65,6.81,6.98,7.15,7.32,7.50,7.68,7.87
930  DATA 8.06,8.25,8.45,8.66,8.87,9.09,9.31,9.53,9.76
940  PRINT:PRINT"                V1 must be the most positive voltage, and"
950  PRINT "                V2 must be the most negative voltage!"
960  PRINT "                Please re-enter V1 and V2":PRINT:GOTO 240
970  PRINT:PRINT"                V3 is the voltage to be generated by R1 and R2"
980  PRINT "                V3 must lie between V1 and V2!"
990  PRINT "                Please re-enter desired V3 voltage:":PRINT:GOTO 270
